<template>
  <zj-tab-page ref="tabPage" :defaultActives="[{ key: 'list', label: $route.meta.title + '-列表', essential: true }]">
    <template slot-scope="{ activeKey, data }">
      <template-page
        v-if="activeKey == 'list'"
        ref="pageRef"
        :get-list="getList"
        :table-attributes="tableAttributes"
        :table-events="tableEvents"
        :options-evens-group="optionsEvensGroup"
        :moreParameters="moreParameters"
        :column-parsing="columnParsing"
        :operation="operation()"
        :exportList="exportList"
      >
      </template-page>
      <div v-if="~['add', 'edit', 'detail'].indexOf(activeKey)">
        <zj-form-container ref="formRef" :form-data="formData" :styleSwitch="false">
          <zj-form-module
            title=""
            label-width="100px"
            :showPackUp="false"
            :form-data="formData"
            :form-items="formItems"
          >
          </zj-form-module>
        </zj-form-container>
        <div slot="footer" class="dialog-footer">
          <el-button size="mini" @click="data.removeTab()">取 消</el-button>
          <el-button size="mini" @click="formConfirm(data.removeTab)" type="primary">确 定</el-button>
        </div>
      </div>
    </template>
  </zj-tab-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import { required, mobileRequired, mobile } from '@/components/template/rules_verify.js'
import {
  storageListPageV2,
  storagePageExport,
  addStorage,
  deleteStorage,
  editStorage,
  getStorageDetail,
  getWebsitList
} from '@/api/storage'
import operation_mixin from '@/components/template/operation_mixin.js'
export default {
  components: { TemplatePage },
  mixins: [import_mixin, operation_mixin],
  data() {
    return {
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialogType: 0,
      formDialogTitles: ['新增', '编辑'],
      formDialog: false,
      formData: {
        storageName: '',
        storageMobile: '',
        storageAddress: '',
        status: true,
        type: [],
        websitId: '',
        websitName: '',
        isDefault: false
      },
      formType: 'add',
      formVisible: false,
      websitList: [],
      joinCode: JSON.parse(localStorage.getItem('greemall_user')).joinCode
    }
  },
  computed: {
    // 事件组合
    optionsEvensGroup() {
      return [
        [
          [
            this.optionsEvensAuth('add', {
              click: () => {
                this.openForm('add')
              }
            })
          ]
        ]
      ]
    },
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [
        {
          md: 6,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入' },
          formItemAttributes: {
            label: '仓储名称',
            prop: 'storageName',
            rules: [...required]
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入' },
          formItemAttributes: {
            label: '仓储电话',
            prop: 'storageMobile',
            rules: [...mobile]
          }
        },
        {
          md: 12,
          isShow: true,
          name: 'el-input',
          attributes: { placeholder: '请输入' },
          formItemAttributes: {
            label: '仓储地址',
            prop: 'storageAddress',
            rules: []
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-checkbox',
          options: [
            {
              value: '辅材',
              label: '辅材',
              disabled: this.formDialogType == 1 || this.formData.type.indexOf('商品') >= 0
            },
            {
              value: '配件',
              label: '配件',
              disabled: this.formDialogType == 1 || this.formData.type.indexOf('商品') >= 0
            }
          ],
          // attributes: { disabled: this.formDialogType == 1 },
          formItemAttributes: {
            label: '仓储属性',
            prop: 'type',
            rules: this.joinCode == 'NO' ? [] : [...required]
          }
        },
        {
          md: 6,
          isShow: this.formData.type.length > 0 && this.formData.type.indexOf('商品') < 0,
          name: 'el-select',
          options: this.websitList.map(item => ({ ...item, label: `(${item.value})${item.label}` })),
          attributes: { filterable: true, placeholder: '请选择', disabled: this.formDialogType == 1 },
          formItemAttributes: {
            label: '所属网点',
            prop: 'websitId',
            rules: [...required]
          },
          events: {
            change: () => {
              this.formData.websitName = this.websitList.find(o => o.value == this.formData.websitId).label
            }
          }
        },
        {
          md: 6,
          isShow: true,
          name: 'el-radio',
          options: [
            { value: true, label: '启用' },
            { value: false, label: '禁用' }
          ],
          attributes: { disabled: this.formData.isDefault },
          formItemAttributes: {
            label: '状态',
            prop: 'status',
            rules: [...required]
          }
        }
      ]
    }
  },
  methods: {
    // 列表请求函数
    getList: storageListPageV2,
    // 列表导出函数
    exportList: storagePageExport,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
    // 表格操作列
    operation() {
      return this.operationBtn({
        edit: {
          btnType: 'text',
          click: ({ row, index, column }) => {
            this.openForm('edit', row.storageId)
          }
        },
        del: {
          btnType: 'text',
          prompt: '确定删除吗？',
          click: ({ row, index, column }) => {
            deleteStorage({ storageId: row.storageId }).then(() => {
              this.$message({ type: 'success', message: '删除成功!' })
              this.$refs.pageRef.refreshList()
            })
          }
        }
      })
    },
    // 打开 新增编辑 网点表单
    openForm(type, id) {
      this.$refs.tabPage.addTab({
        // 对应显示的模块
        activeKey: type,
        // 唯一标识
        key: type,
        // 页签名称
        label: { edit: '编辑', add: '新增' }[type],
        // 打开时事件
        triggerEvent: () => {
          this.formCancel()
          this.$nextTick(() => {
            this.formType = type
            this.formVisible = true
            getWebsitList({
              status: 1,
              type: 'C'
            }).then(res => {
              this.websitList = res.data.map(item => ({
                label: item.name,
                value: item.websitId,
                data: item
              }))
              if (this.websitList.length === 1 && type === 'add') {
                this.formData.websitId = this.websitList[0].websitId
                this.formData.websitName = this.websitList[0].websitName
              }
            })
            if (type == 'add') {
              this.formDialogType = 0
            } else if (type == 'edit') {
              this.formDialogType = 1
              getStorageDetail({ id }).then(res => {
                res.data.type = res.data.type.split(',')
                Object.assign(this.formData, res.data)
              })
            }
          })
        },
        // 关闭时事件
        closeEvent: () => {}
      })
    },
    formCancel() {
      this.formVisible = false
      this.$refs?.formRef?.resetFields()
      this.$data.formData = this.$options.data().formData
    },
    formConfirm(cancel) {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          ;[addStorage, editStorage]
            [this.formDialogType]({ ...this.formData, type: this.formData.type.join(',') })
            .then(res => {
              this.$message({ type: 'success', message: `${this.formDialogTitles[this.formDialogType]}成功!` })
              cancel('list')
              this.$refs.pageRef.refreshList()
            })
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped></style>
